 namespace std {
typedef long size_t;
}
typedef char uint8_t;
namespace std {
template <typename _Tp, _Tp __v> struct integral_constant {
  static constexpr _Tp value = __v;
};
typedef integral_constant<bool, false> false_type;
template <bool, typename, typename> struct conditional;
template <typename > struct is_void : false_type {};
template <typename _Tp> struct remove_reference ;
template <typename _Tp> struct remove_reference<_Tp &> { typedef _Tp type; };
template <typename _Iftrue, typename _Iffalse>
struct conditional<false, _Iftrue, _Iffalse> {
  typedef _Iffalse type;
};
template <typename , typename ,
          template <typename...>   typename >
struct __detector;
template <typename _Default, template <typename...> class _Op
           >
using __detected_or = __detector<_Default, void, _Op>;
template <typename _Default, template <typename> class _Op
           >
using __detected_or_t = typename __detected_or<_Default, _Op>::type;
template <template <typename...> class _Default,
          template <typename> class _Op, typename... _Args>
using __detected_or_t_ = __detected_or_t<_Default<_Args...>, _Op>;
template <typename _Tp>
 forward(typename _Tp::type __t) {
}
template <typename _Tp>
typename remove_reference<_Tp>::type move(_Tp &&__t) {
  return static_cast<typename remove_reference<_Tp>::type &&>(__t);
}struct forward_iterator_tag ;
struct iterator;
template <typename , typename > struct __replace_first_arg;
template <typename _Tp, typename _Up>
using __replace_first_arg_t = typename __replace_first_arg<_Tp, _Up>::type;
}
inline void *operator new(std::size_t, void *__p) { return __p; }
namespace __gnu_cxx {
  template <typename > class new_allocator ;
}
namespace std {
template <typename _Tp> using __allocator_base = __gnu_cxx::new_allocator<_Tp>;
template <typename _Tp> class allocator :  __allocator_base<_Tp> {};
struct __allocator_traits_base {
  template <typename _Alloc>
  using __rebind = typename _Alloc::other;
};
template <typename _Alloc, typename _Up>
using __alloc_rebind =
    __detected_or_t_<__replace_first_arg_t, __allocator_traits_base::__rebind,
                     _Alloc, _Up>;
template <typename _Tp> struct allocator_traits ;
  template <typename _Alloc>
  struct __alloc_traits : std::allocator_traits<_Alloc> {
  };
}

namespace padis {
namespace listener {
namespace tlv {
namespace _v1 {
namespace traits {
template <typename CodeType, std::size_t ,
          std::size_t , std::size_t >
struct generic_tlv_config {
  typedef CodeType code_type;
};
}
template <typename TlvConfig> class GenericTlv {
  virtual typename TlvConfig::code_type getCode() ;
};
template <typename TlvConfig, typename TlvConfig::code_type , class ImplClass>
class GenericTlvBase : GenericTlv<TlvConfig> {
  virtual bool operator==(const ImplClass &) const ;
};
}
}
  }
}
namespace mpl_ {}
namespace boost {
namespace mpl {
using namespace mpl_;
}
}
namespace mpl_ {
template <int N> struct int_ { static const int value = N; };
}
namespace boost {
namespace mpl {
namespace aux {
template <typename > struct template_arity;
}
}
}
namespace mpl_ {
template <bool > struct bool_;
typedef bool_<true> true_;
typedef bool_<false> false_;
template <bool C_> struct bool_ {
  static const bool value = C_;
};
template <typename T, T > struct integral_c;
template <bool C> struct integral_c<bool, C> { static const bool value = C; };
}
namespace boost {
template <class T, T val>
struct integral_constant : mpl::integral_c<T, val> {};
template <typename >
struct is_lvalue_reference :integral_constant<bool, false> {
};
template <typename >
struct is_rvalue_reference :integral_constant<bool, false> {
};
namespace type_traits {
template <bool , bool >
struct ice_or;
template <> struct ice_or<false, false> {
  static const bool value = false;
};
}
namespace detail {
template <typename T> struct is_reference_impl {
  static const bool value =
      type_traits::ice_or<is_lvalue_reference<T>::value,
                                 is_rvalue_reference<T>::value>::value;
};
}
template <typename T>
struct is_reference :integral_constant<
                          bool, detail::is_reference_impl<T>::value> {
};
}
namespace mpl_ {
struct void_;
struct na {
  typedef na type;
  enum { value };
};
}
namespace boost {
namespace mpl {
template <typename > struct is_na : true_ {};
template <typename T , typename = void_,
          typename = int_<aux::template_arity<T>::value>>
struct lambda;
template <bool , typename T1, typename > struct if_c { typedef T1 type; };
template <typename T1, typename T2> struct if_c<false, T1, T2> {
  typedef T2 type;
};
template <typename T1 , typename T2 , typename T3 = na> struct if_ {
  typedef if_c<T1::value, T2, T3> almost_type_;
  typedef typename almost_type_::type type;
};
namespace aux {
template <typename T> struct nested_type_wknd : T{};
template <bool , typename , typename , typename , typename >
struct or_impl : true_ {};
template <typename T1, typename T2, typename T3, typename T4>
struct or_impl<false, T1, T2, T3, T4>
    : or_impl<T1::value, T2, T3, T4,
              false_> {};
template <> struct or_impl<false, false_, false_, false_, false_> : false_ {};
}
template <typename T1 = na, typename T2 = na, typename T3 = false_,
          typename T4 = false_, typename T5 = false_>
struct or_ : aux::or_impl<aux::nested_type_wknd<T1>::value, T2, T3,
                          T4, T5> {};
}
template <int > struct arg;
}
namespace boost {
namespace mpl {
namespace {
typedef (yes_tag);
}
}
template <> struct arg<1> {
  template <typename U1 , typename >
  struct apply {
    typedef U1 type;
  };
};
template <> struct arg<2> ;
namespace mpl {
namespace aux {
template <typename > struct type_wrapper ;
template <int , int , int , int , int , int > struct max_arity {
  static const int value =
      1;
};
template <typename , int > struct template_arity_impl {
  static const int value = 1;
};
template <typename F> struct template_arity {
  static const int value = max_arity<
      template_arity_impl<F, 1>::value, template_arity_impl<F, 2>::value,
      template_arity_impl<F, 3>::value, template_arity_impl<F, 4>::value,
      template_arity_impl<F, 5>::value,
      template_arity_impl<F, 6>::value>::value;
};
}
}
namespace detail {
namespace variant {
template <typename T> class backup_holder {
  T *backup_;
public:
  T get() { return *backup_; }
};
template <typename > struct is_recursive_flag : mpl::false_ {};
}
template <typename T = mpl::void_> struct make_reference_content { typedef T type; };
template <> struct make_reference_content<> ;
}
template <typename T> struct unwrap_recursive { typedef T type; };

namespace mpl {
template <typename C = na, typename F1 = na, typename F2 = na> struct eval_if {
  typedef typename if_<C, F1, F2>::type ::type type;
};
template <bool C, typename F1, typename F2> struct eval_if_c ;
namespace aux {
template <typename = bool_<true>>
struct has_begin {
  static const bool value =
      sizeof(yes_tag);
};
}
template <typename > struct begin_impl;
namespace aux {
template <typename = bool_<false>>
struct has_tag {
  struct gcc_3_2_wknd {
    template <typename U>
    yes_tag
    test(type_wrapper<U> );
  };
  static const bool value = sizeof(gcc_3_2_wknd);
};
template <bool , bool > struct sequence_tag_impl{
  template <typename Sequence> struct result2_ {
    typedef typename Sequence::tag type;
  };
};
}
template <typename Sequence >
struct sequence_tag
    : aux::sequence_tag_impl<aux::has_tag<>::value,
                             aux::has_begin<>::value>::
          result2_<Sequence> {};
template <typename Sequence > struct begin {
  typedef typename sequence_tag<Sequence>::type tag_;
  typedef typename begin_impl<tag_>::template apply<Sequence>::type type;
};
template <typename Sequence > struct end ;
}
template <long N> struct long_ {
  static const long value = N;
};
namespace mpl {
namespace aux {
template <typename = bool_<false>>
struct has_size {
  struct gcc_3_2_wknd {
    template <typename U>
    yes_tag
    test(type_wrapper<U> );
  };
  static const bool value = sizeof(gcc_3_2_wknd);
};
template <typename Sequence> struct O1_size_impl : Sequence::size {};
}
template <typename > struct O1_size_impl {
  template <typename Sequence>
  struct apply
      : if_<aux::has_size<>, aux::O1_size_impl<Sequence>>::type {};
};
template <typename Sequence >
struct O1_size
    : O1_size_impl<typename Sequence::type>::template apply<
          Sequence> {};
template <typename , typename , typename , typename , typename >
struct bind4;
}
typedef arg<1> _1;
typedef arg<2> _2;
namespace mpl {
template <typename > struct next ;
template <typename T , int = 0> struct protect : T {};
template <typename F, typename T1, typename T2>
struct apply_wrap2 : F::template apply<T1, T2> {};
template <typename F, typename T1, typename T2, typename , typename ,
          typename >
struct apply_wrap5 : F::template apply {};
namespace aux {
template <typename T, typename , typename , typename , typename ,
          typename >
struct resolve_bind_arg ;
template <int N, typename U1, typename U2, typename U3, typename U4,
          typename U5>
struct resolve_bind_arg<arg<N>, U1, U2, U3, U4, U5> ;
template <typename F, typename T1, typename T2, typename T3, typename T4,
          typename >
struct resolve_bind_arg;
}
template <typename F, typename T1> struct bind1 ;

template <typename F, typename T1, typename T2> struct bind2 ;
template <typename T, typename , typename > struct lambda {
  typedef T type;
};
template <template <typename , typename > class F, typename T1, typename T2,
          typename Tag>
struct lambda<F<T1, T2>, Tag>;
template <template <typename , typename , typename , typename > class F,
          typename T1, typename T2, typename T3, typename T4, typename Tag>
struct lambda<F<T1, T2, T3, T4>, Tag>;
template <typename F, typename T1, typename T2, typename T3, typename T4,
          typename Tag>
struct lambda<bind4<F, T1, T2, T3, T4>, Tag>;
template <template <typename , typename , typename , typename ,
                    typename > class F,
          typename T1, typename T2, typename T3, typename T4, typename T5,
          typename Tag>
struct lambda<F<T1, T2, T3, T4, T5>, Tag>;
template <typename F, typename T1, typename T2>
struct apply2 : apply_wrap2<typename lambda<F>::type, T1, T2> {};
namespace aux {
template <int , typename , typename , typename ,
          typename >
struct iter_fold_impl;
template <typename First, typename Last, typename State, typename ForwardOp>
struct iter_fold_impl<2, First, Last, State, ForwardOp> {
  typedef First iter0;
  typedef State state1;
  typedef typename next<iter0>::type iter1;
  typedef typename apply2<ForwardOp, state1, iter1>::type state;
};
}
template <typename Sequence , typename State , typename ForwardOp >
struct iter_fold {
  typedef typename aux::iter_fold_impl<
      O1_size<Sequence>::value, typename begin<Sequence>::type,
      typename Sequence::type, State,
      typename lambda<ForwardOp>::type>::state type;
};
template <typename Iterator > struct deref {
  typedef typename Iterator::type type;
};
template <typename T1 > struct pair { typedef T1 first; };
}
namespace detail {
namespace variant {
struct make_initializer_node {
  template <typename , typename Iterator> struct apply {
    class initializer_node {
      typedef typename mpl::deref<Iterator>::type recursive_enabled_T;
      typedef typename unwrap_recursive<recursive_enabled_T>::type public_T;
      typedef is_reference<public_T> is_reference_content_t;
      typedef typename mpl::if_<is_reference_content_t, public_T,
                                        public_T >::type param_T;
    public:
      static initialize(void *dest, param_T ) {
        typedef typename make_reference_content<
            recursive_enabled_T>::type internal_T;
        new (dest) internal_T;
      }
    };
    typedef mpl::pair<initializer_node> type;
  };
};
}
}
namespace mpl {
template <typename > struct push_front_impl;
namespace aux {
struct list_tag;
}
template <typename Size, typename T, typename Next> struct l_item {
  typedef aux::list_tag tag;
  typedef l_item type;
  typedef Size size;
  typedef T item;
  typedef Next next;
};
struct l_end ;
template <> struct push_front_impl<aux::list_tag> ;
template <typename > struct has_push_back_impl{
  template <typename > struct apply : false_ {};
};
template <typename Node> struct l_iter { typedef typename Node::item type; };
template <typename Node> struct next<l_iter<Node>> {
  typedef l_iter<Node::next> type;
};
template <> struct begin_impl<aux::list_tag> {
  template <typename List> struct apply {
    typedef l_iter<List> type;
  };
};
template <typename T0> struct list1 : l_item<long_<1>, T0, l_end> {};
template <typename T0, typename T1>
struct list2 : l_item<long_<2>, T0, list1<T1>> {};
template <typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename >
struct list39;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39>
struct l_item<long_<40>, T0,
                       list39<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12,
                              T13, T14, T15, T16, T17, T18, T19, T20, T21, T22,
                              T23, T24, T25, T26, T27, T28, T29, T30, T31, T32,
                              T33, T34, T35, T36, T37, T38, T39>> ;
template <typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename >
struct list42;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42>
struct list43
    : l_item<long_<43>, T0,
             list42<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
                    T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26,
                    T27, T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38,
                    T39, T40, T41, T42>> {};
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43>
struct l_item<long_<44>, T0,
             list43<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
                    T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26,
                    T27, T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38,
                    T39, T40, T41, T42, T43>> ;
template <typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename >
struct list55;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55>
struct l_item<long_<56>, T0,
             list55<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
                    T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26,
                    T27, T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38,
                    T39, T40, T41, T42, T43, T44, T45, T46, T47, T48, T49, T50,
                    T51, T52, T53, T54, T55>> ;
template <typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename >
struct list75;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75>
struct l_item<long_<76>, T0,
             list75<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
                    T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26,
                    T27, T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38,
                    T39, T40, T41, T42, T43, T44, T45, T46, T47, T48, T49, T50,
                    T51, T52, T53, T54, T55, T56, T57, T58, T59, T60, T61, T62,
                    T63, T64, T65, T66, T67, T68, T69, T70, T71, T72, T73, T74,
                    T75>> ;
template <typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename >
struct list92;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75, typename T76, typename T77, typename T78, typename T79,
          typename T80, typename T81, typename T82, typename T83, typename T84,
          typename T85, typename T86, typename T87, typename T88, typename T89,
          typename T90, typename T91, typename T92>
struct list93
    : l_item<long_<93>, T0,
             list92<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
                    T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26,
                    T27, T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38,
                    T39, T40, T41, T42, T43, T44, T45, T46, T47, T48, T49, T50,
                    T51, T52, T53, T54, T55, T56, T57, T58, T59, T60, T61, T62,
                    T63, T64, T65, T66, T67, T68, T69, T70, T71, T72, T73, T74,
                    T75, T76, T77, T78, T79, T80, T81, T82, T83, T84, T85, T86,
                    T87, T88, T89, T90, T91, T92>> {};
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75, typename T76, typename T77, typename T78, typename T79,
          typename T80, typename T81, typename T82, typename T83, typename T84,
          typename T85, typename T86, typename T87, typename T88, typename T89,
          typename T90, typename T91, typename T92, typename T93>
struct l_item<long_<94>, T0,
             list93<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
                    T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26,
                    T27, T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38,
                    T39, T40, T41, T42, T43, T44, T45, T46, T47, T48, T49, T50,
                    T51, T52, T53, T54, T55, T56, T57, T58, T59, T60, T61, T62,
                    T63, T64, T65, T66, T67, T68, T69, T70, T71, T72, T73, T74,
                    T75, T76, T77, T78, T79, T80, T81, T82, T83, T84, T85, T86,
                    T87, T88, T89, T90, T91, T92, T93>> ;
template <typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename , typename ,
          typename , typename , typename , typename >
struct list99;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75, typename T76, typename T77, typename T78, typename T79,
          typename T80, typename T81, typename T82, typename T83, typename T84,
          typename T85, typename T86, typename T87, typename T88, typename T89,
          typename T90, typename T91, typename T92, typename T93, typename T94,
          typename T95, typename T96, typename T97, typename T98, typename T99>
struct list100
    : l_item<long_<100>, T0,
             list99<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
                    T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26,
                    T27, T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38,
                    T39, T40, T41, T42, T43, T44, T45, T46, T47, T48, T49, T50,
                    T51, T52, T53, T54, T55, T56, T57, T58, T59, T60, T61, T62,
                    T63, T64, T65, T66, T67, T68, T69, T70, T71, T72, T73, T74,
                    T75, T76, T77, T78, T79, T80, T81, T82, T83, T84, T85, T86,
                    T87, T88, T89, T90, T91, T92, T93, T94, T95, T96, T97, T98,
                    T99>> {};
template <
    typename , typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na,
    typename = na, typename = na, typename = na, typename = na>
struct list;
template <typename T0, typename T1>
struct list<T0, T1>
    : list2<T0, T1> {};
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52>
struct list<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
            T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27,
            T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40,
            T41, T42, T43, T44, T45, T46, T47, T48, T49, T50, T51, T52>;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75, typename T76, typename T77, typename T78, typename T79,
          typename T80, typename T81, typename T82, typename T83, typename T84,
          typename T85, typename T86, typename T87>
struct list<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
            T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27,
            T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40,
            T41, T42, T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53,
            T54, T55, T56, T57, T58, T59, T60, T61, T62, T63, T64, T65, T66,
            T67, T68, T69, T70, T71, T72, T73, T74, T75, T76, T77, T78, T79,
            T80, T81, T82, T83, T84, T85, T86, T87>;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75, typename T76, typename T77, typename T78, typename T79,
          typename T80, typename T81, typename T82, typename T83, typename T84,
          typename T85, typename T86, typename T87  >
struct list<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
            T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27,
            T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40,
            T41, T42, T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53,
            T54, T55, T56, T57, T58, T59, T60, T61, T62, T63, T64, T65, T66,
            T67, T68, T69, T70, T71, T72, T73, T74, T75, T76, T77, T78, T79,
            T80, T81, T82, T83, T84, T85, T86, T87>;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75, typename T76, typename T77, typename T78, typename T79,
          typename T80, typename T81, typename T82, typename T83, typename T84,
          typename T85, typename T86, typename T87>
struct list<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
            T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27,
            T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40,
            T41, T42, T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53,
            T54, T55, T56, T57, T58, T59, T60, T61, T62, T63, T64, T65, T66,
            T67, T68, T69, T70, T71, T72, T73, T74, T75, T76, T77, T78, T79,
            T80, T81, T82, T83, T84, T85, T86, T87>;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75, typename T76, typename T77, typename T78, typename T79,
          typename T80, typename T81, typename T82, typename T83, typename T84,
          typename T85, typename T86, typename T87>
struct list<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
            T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27,
            T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40,
            T41, T42, T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53,
            T54, T55, T56, T57, T58, T59, T60, T61, T62, T63, T64, T65, T66,
            T67, T68, T69, T70, T71, T72, T73, T74, T75, T76, T77, T78, T79,
            T80, T81, T82, T83, T84, T85, T86, T87>;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75, typename T76, typename T77, typename T78, typename T79,
          typename T80, typename T81, typename T82, typename T83, typename T84,
          typename T85, typename T86, typename T87>
struct list<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
            T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27,
            T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40,
            T41, T42, T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53,
            T54, T55, T56, T57, T58, T59, T60, T61, T62, T63, T64, T65, T66,
            T67, T68, T69, T70, T71, T72, T73, T74, T75, T76, T77, T78, T79,
            T80, T81, T82, T83, T84, T85, T86, T87>;
template <typename T0, typename T1, typename T2, typename T3, typename T4,
          typename T5, typename T6, typename T7, typename T8, typename T9,
          typename T10, typename T11, typename T12, typename T13, typename T14,
          typename T15, typename T16, typename T17, typename T18, typename T19,
          typename T20, typename T21, typename T22, typename T23, typename T24,
          typename T25, typename T26, typename T27, typename T28, typename T29,
          typename T30, typename T31, typename T32, typename T33, typename T34,
          typename T35, typename T36, typename T37, typename T38, typename T39,
          typename T40, typename T41, typename T42, typename T43, typename T44,
          typename T45, typename T46, typename T47, typename T48, typename T49,
          typename T50, typename T51, typename T52, typename T53, typename T54,
          typename T55, typename T56, typename T57, typename T58, typename T59,
          typename T60, typename T61, typename T62, typename T63, typename T64,
          typename T65, typename T66, typename T67, typename T68, typename T69,
          typename T70, typename T71, typename T72, typename T73, typename T74,
          typename T75, typename T76, typename T77, typename T78, typename T79,
          typename T80, typename T81, typename T82, typename T83, typename T84,
          typename T85, typename T86, typename T87, typename T88, typename T89,
          typename T90, typename T91, typename T92, typename T93, typename T94,
          typename T95, typename T96, typename T97, typename T98, typename T99>
struct list
    : list100<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14,
              T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27,
              T28, T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40,
              T41, T42, T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53,
              T54, T55, T56, T57, T58, T59, T60, T61, T62, T63, T64, T65, T66,
              T67, T68, T69, T70, T71, T72, T73, T74, T75, T76, T77, T78, T79,
              T80, T81, T82, T83, T84, T85, T86, T87, T88, T89, T90, T91, T92,
              T93, T94, T95, T96, T97, T98, T99> {};
}
namespace detail {
namespace variant {
template <typename... T> struct make_variant_list {
  typedef mpl::list<T...>type;
};
template <typename > struct is_over_sequence : mpl::false_ {};
template <typename T> T cast_storage(void *storage) {
  return *static_cast<T *>(storage);
}
}
}
namespace mpl {
template <typename T > struct identity { typedef T type; };
};
namespace detail {
namespace variant {
template <typename Iter, typename > struct visitation_impl_step {
  typedef typename mpl::deref<Iter>::type type;
};
template <typename Visitor, typename VoidPtrCV, typename T>
visitation_impl_invoke_impl(int , Visitor visitor,
                            VoidPtrCV storage, T *, mpl::false_) {
  visitor.internal_visit(cast_storage<backup_holder<T>>(storage), 1);
}
template <typename Visitor, typename VoidPtrCV, typename T,
          typename NoBackupFlag>
visitation_impl_invoke(int internal_which, Visitor visitor, VoidPtrCV storage,
                       T t, NoBackupFlag, int) {
  typedef mpl::or_<>never_uses_backup;
  visitation_impl_invoke_impl(internal_which, visitor, storage, t,
                                     never_uses_backup());
}
template <typename Which, typename step0, typename Visitor, typename VoidPtrCV,
          typename NoBackupFlag>
visitation_impl(int internal_which, int logical_which,
                Visitor visitor, VoidPtrCV storage, mpl::false_,
                NoBackupFlag no_backup_flag, Which , step0 * ) {
  typedef typename step0::type T0;
  switch (logical_which) 
  case 0:
    visitation_impl_invoke(internal_which, visitor, storage,
                                  static_cast<T0 *>(0), no_backup_flag, 1);
}
}typedef void static_visitor_default_return;
}
template <typename R = detail::static_visitor_default_return>
class static_visitor {
public:
  typedef R result_type;
};
namespace detail {
union max_align ;
}
template <std::size_t > class type_with_alignment;
namespace detail {
namespace aligned_storage {
template <std::size_t , std::size_t alignment_>
struct aligned_storage_imp {
  union {
    typename mpl::eval_if_c<
        alignment_ ,
        mpl::identity<::boost::detail::max_align>,
        type_with_alignment<alignment_>>;
  } ;
};
}
}
template <std::size_t size_, std::size_t alignment_ = 1>
class aligned_storage
    :detail::aligned_storage::aligned_storage_imp<size_, alignment_> {
public:
  typedef detail::aligned_storage::aligned_storage_imp<size_,
                                                                alignment_>
      type;
  void *address() { return static_cast<type *>(this); }
}
;
namespace math {
}
namespace mpl {
namespace {
template <int , typename , typename , typename ,
          typename >
struct fold_impl;
}
template <typename Sequence = na, typename T = na>
struct push_front
    : push_front_impl<typename sequence_tag<Sequence>::type>::template apply<
          Sequence, T> {};
template <> struct push_front<> {
};
template <typename Tag> struct lambda<push_front<>, Tag, int_<-1>> {
  typedef push_front<> type;
};
namespace aux {
template <typename T1, typename T2>
struct template_arity<push_front<T1, T2>> ;
template <> struct template_arity<push_front<>> : int_<-1> {};
template <long , typename , typename , typename ,
          typename , typename >
struct reverse_fold_impl;
template <typename First, typename Last, typename State, typename BackwardOp,
          typename ForwardOp>
struct reverse_fold_impl<2, First, Last, State, BackwardOp, ForwardOp> {
  typedef First iter0;
  typedef State fwd_state0;
  typedef typename apply2<ForwardOp, fwd_state0,
                          typename iter0::type>::type fwd_state1;
  typedef typename apply2<ForwardOp, fwd_state1,
                          typename iter0::type>::type state;
};
template <typename First, typename Last, typename State, typename BackwardOp,
          typename ForwardOp>
struct reverse_fold_impl<1, First, Last, State, BackwardOp, ForwardOp>;
template <typename Last, typename State, typename BackwardOp,
          typename ForwardOp>
struct reverse_fold_impl<1, Last, Last, State, BackwardOp, ForwardOp>;
}
template <typename Sequence , typename State , typename BackwardOp ,
          typename ForwardOp = arg<1>>
struct reverse_fold {
  typedef typename aux::reverse_fold_impl<
      O1_size<Sequence>::value, typename begin<Sequence>::type,
      typename Sequence::type, State, BackwardOp, ForwardOp>::state type;
};
template <typename Sequence >
struct has_push_back
    : has_push_back_impl<typename Sequence::type>::template apply<
          Sequence> {};
template <typename Sequence, typename Operation> struct inserter {
  typedef Sequence state;
  typedef Operation operation;
};
template <typename > struct back_inserter;
template <typename Sequence>
struct front_inserter : inserter<Sequence, push_front<>> {};
namespace aux {
template <typename , typename , typename > struct transform1_impl;
template <typename Seq, typename Op, typename In>
struct reverse_transform1_impl
    : reverse_fold<Seq, In::state,
                   bind2<typename lambda<In::operation>::type, _1,
                         bind1<typename lambda<Op>::type, _2>>> {};
template <typename , typename , typename , typename >
struct transform2_impl;
template <typename , typename , typename , typename >
struct reverse_transform2_impl;
}
template <typename = na, typename = na, typename = na>
struct transform1 ;
template <typename P1, typename P2>
struct transform1<P1, P2>
    : if_<has_push_back<typename P1::type>,
          aux::transform1_impl<P1, P2, back_inserter<typename P1::type>>,
          aux::reverse_transform1_impl<
              P1, P2, front_inserter<typename P1::type>>>::type {};
template <typename = na, typename = na, typename = na,
          typename = na>
struct transform2 ;
template <typename P1, typename P2, typename P3>
struct transform2<P1, P2, P3>
    : if_<aux::transform2_impl<P1, P2, P3,
                               back_inserter<typename P1::type>>,
          aux::reverse_transform2_impl<
              P1, P2, P3, front_inserter<typename P1::type>>>{};
template <typename = na, typename = na, typename = na,
          typename = na>
struct reverse_transform2 ;
template <typename P1, typename P2, typename P3>
struct reverse_transform2<P1, P2, P3>
    : if_<has_push_back<back_inserter<typename P1::type>>,
          aux::transform2_impl<
              P1, P2, P3, front_inserter<typename P1::type>>>{};
template <typename Tag>
struct lambda<Tag, int_<1>>;
namespace aux {
}
template <typename Seq1 = na, typename Seq2OrOperation = na,
          typename OperationOrInserter = na, typename = na>
struct transform {
  typedef typename eval_if<
      or_<is_na<OperationOrInserter>>,
      transform1<Seq1, Seq2OrOperation>>::type
      type;
};
namespace aux {
}
}
namespace detail {
namespace variant {
template <typename , typename > struct make_storage {
  typedef mpl::eval_if<>::type max_size;
  typedef boost::aligned_storage<max_size::value> type;
};
class move_into : public static_visitor<> {
  *storage_;
public:
  move_into(void *) ;
  template <typename T>
  internal_visit(backup_holder<T> operand,
                      long) {
    new (storage_) T(operand.get());
  }
};
}
}
template <typename T0_, typename... TN> class variant {
  struct is_recursive_ : detail::variant::is_recursive_flag<T0_> {};
  typedef typename mpl::eval_if<is_recursive_, T0_, mpl::identity<T0_>>::type
      unwrapped_T0_;
  struct is_sequence_based_ : detail::variant::is_over_sequence<unwrapped_T0_> {
  };
  typedef typename mpl::eval_if<
      is_sequence_based_, unwrapped_T0_,
      detail::variant::make_variant_list<unwrapped_T0_, TN...>>::type
      recursive_enabled_types;
  typedef typename mpl::transform<
      recursive_enabled_types,
      mpl::protect<detail::make_reference_content<>>>::type internal_types;
  struct has_fallback_type_ {}
  typedef  never_uses_backup_flag;
  typedef typename detail::variant::make_storage<
      internal_types, never_uses_backup_flag>::type storage_t;
  typedef int which_t;
  which_t which_;
  storage_t storage_;
  which() {}
  struct initializer
      :mpl::iter_fold<
            recursive_enabled_types,
            mpl::pair<::boost::mpl::int_<0>>,
            mpl::protect<
                detail::variant::make_initializer_node>>::type::first {
  };
  template <typename T> convert_construct(T operand, int) {
    initializer::initialize(storage_.address(), operand);
  }
public:
  template <typename T> variant(T operand) {
    convert_construct(operand, 1);
  }
  variant(variant &&operand) {
    detail::variant::move_into visitor(storage_.address());
    operand.internal_apply_visitor(visitor);
  }template <typename Visitor, typename VoidPtrCV>
  internal_apply_visitor_impl(int internal_which, int logical_which,
                              Visitor visitor, VoidPtrCV storage) {
    typedef mpl::int_<0> first_which;
    typedef typename mpl::begin<internal_types>::type first_it;
    typedef mpl::end<internal_types>last_it;
    typedef detail::variant::visitation_impl_step<first_it, last_it> first_step;
    detail:visitation_impl(
        internal_which, logical_which, visitor, storage, mpl::false_(),
        never_uses_backup_flag(), static_cast<first_which *>(0),
        static_cast<first_step *>(0));
  }
  template <typename Visitor>
  typename Visitor::result_type internal_apply_visitor(Visitor visitor) {
    internal_apply_visitor_impl(which_, which(), visitor,
                                       storage_.address());
  }
};
}
namespace padis {
namespace listener {
namespace tlv {
inline namespace _v1 {
namespace traits {
template <class... >
struct generic_element_tlvs;
template <typename TlvConfig, class UnsupportedTlvClass, class TlvF,
          class... TlvR>
struct generic_element_tlvs<TlvConfig, UnsupportedTlvClass, TlvF, TlvR...> {
  typedef typename std::conditional<
      std::is_void<UnsupportedTlvClass>::value, boost::variant<TlvF>,
      boost::variant<UnsupportedTlvClass, TlvF>>::type variant_type;
};
}
template <typename , typename ElementTlvs> class GenericTlvContainer {
public:
  typedef typename ElementTlvs::variant_type tlv_type;
  template <class TlvClass> void addTlv(const TlvClass &);
};
template <typename TlvConfig, typename ElementTlvs>
template <class TlvClass>
void
GenericTlvContainer<TlvConfig, ElementTlvs>::addTlv(const TlvClass &tlv) {
  tlv_type wrap(tlv);
  std::move(wrap);
}
template <typename TlvConfig, typename TlvConfig::code_type Id, class ImplClass,
          std::size_t , std::size_t >
class GenericFixedLengthTlvBase
    : GenericTlvBase<TlvConfig, Id, ImplClass> {
};
template <typename TlvConfig>
class GenericUnsupportedTlv : TlvConfig {
  std::size_t length_;
};
}
}
}
namespace isislistener {
namespace tlv {
namespace traits {
using isis_tlv_config =
    listener::tlv::traits::generic_tlv_config<uint8_t, 2, 1, 255>;
template <class... TlvClasses>
using isis_element_tlvs = listener::tlv::traits::generic_element_tlvs<
    isis_tlv_config, listener::tlv::GenericUnsupportedTlv<isis_tlv_config>,
    TlvClasses...>;
}
template <uint8_t Id, class ImplClass, std::size_t MinLen,
          std::size_t MaxLen = MinLen>
using FixedLengthTlvBase =
    listener::tlv::GenericFixedLengthTlvBase<traits::isis_tlv_config, Id,
                                             ImplClass, MinLen, MaxLen>;
namespace te {
class IPv4NeighborAddressSubTlv
    : FixedLengthTlvBase<8, IPv4NeighborAddressSubTlv, 4> {
  bool operator==(const IPv4NeighborAddressSubTlv &) const ;
};
}
typedef traits::isis_element_tlvs<te::IPv4NeighborAddressSubTlv>
    extended_is_reachability_sub_tlvs;
class ExtendedIsReachabilityEntry
    : public listener::tlv::GenericTlvContainer<
          traits::isis_tlv_config, extended_is_reachability_sub_tlvs> {};
}
void test() {
  tlv::ExtendedIsReachabilityEntry isEntry;
  tlv::te::IPv4NeighborAddressSubTlv nbAddressSubTlv;
  isEntry.addTlv(nbAddressSubTlv);
}
}
}
 